#
# Conditional build:
%bcond_without	dist_kernel	# allow non-distribution kernel
%bcond_without	allprobes	# all probes build (some probes, e.g. fs, need full kernel source)
%bcond_with	verbose		# verbose build (V=1)

%if "%{_alt_kernel}" != "%{nil}"
%if 0%{?build_kernels:1}
%{error:alt_kernel and build_kernels are mutually exclusive}
exit 1
%endif
%global		_build_kernels		%{alt_kernel}
%else
%global		_build_kernels		%{?build_kernels:,%{?build_kernels}}
%endif

# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0

%define		kpkg	%(echo %{_build_kernels} | tr , '\\n' | while read n ; do echo %%undefine alt_kernel ; [ -z "$n" ] || echo %%define alt_kernel $n ; echo %%kernel_pkg ; done)
%define		bkpkg	%(echo %{_build_kernels} | tr , '\\n' | while read n ; do echo %%undefine alt_kernel ; [ -z "$n" ] || echo %%define alt_kernel $n ; echo %%build_kernel_pkg ; done)

%define		rel	3
%define		pname	lttng-modules
Summary:	LTTng 2.x kernel modules
Summary(pl.UTF-8):	Moduły jądra LTTng 2.x
Name:		%{pname}%{_alt_kernel}
Version:	2.5.1
Release:	%{rel}@%{_kernel_ver_str}
License:	GPL v2
Group:		Base/Kernel
Source0:	http://lttng.org/files/lttng-modules/%{pname}-%{version}.tar.bz2
# Source0-md5:	2d99bb7311ba92e82e3b675f0b8dee7d
Patch0:		build.patch
Patch1:		linux-3.17.patch
Patch2:		linux-3.14.25.patch
URL:		http://lttng.org/
%if %{with dist_kernel}
BuildRequires:	kernel%{_alt_kernel}-module-build >= 3:2.6.38
%{?with_allprobes:BuildRequires:	kernel%{_alt_kernel}-source >= 3:2.6.38}
%endif
BuildRequires:	rpmbuild(macros) >= 1.678
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
LTTng 2.x kernel modules.

%description -l pl.UTF-8
Moduły jądra LTTng 2.x.

%define	kernel_pkg()\
%package -n kernel%{_alt_kernel}-lttng\
Summary:	LTTng 2.x modules for Linux kernel\
Summary(pl.UTF-8):	Moduły LTTng 2.x dla jądra Linuksa\
Release:	%{rel}@%{_kernel_ver_str}\
Group:		Base/Kernel\
Requires(post,postun):	/sbin/depmod\
%if %{with dist_kernel}\
%requires_releq_kernel\
Requires(postun):	%releq_kernel\
%endif\
\
%description -n kernel%{_alt_kernel}-lttng\
LTTng 2.x modules for Linux kernel.\
\
%description -n kernel%{_alt_kernel}-lttng -l pl.UTF-8\
Moduły LTTng 2.x dla jądra Linuksa.\
\
%files -n kernel%{_alt_kernel}-lttng\
%defattr(644,root,root,755)\
%doc ChangeLog LICENSE README TODO\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-ring-buffer-*.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-statedump.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-tracer.ko*\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng/lib\
/lib/modules/%{_kernel_ver}/kernel/lttng/lib/lttng-lib-ring-buffer.ko*\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng/probes\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-ftrace.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-kprobes.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-kretprobes.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-probe-*.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-types.ko*\
\
%post	-n kernel%{_alt_kernel}-lttng\
%depmod %{_kernel_ver}\
\
%postun	-n kernel%{_alt_kernel}-lttng\
%depmod %{_kernel_ver}\
%{nil}

%define build_kernel_pkg()\
%{__make} \\\
	KERNELDIR=%{_kernelsrcdir} \\\
	EXTCFLAGS="%{rpmcflags}"\
p=`pwd`\
%{__make} modules_install \\\
	INSTALL_MOD_PATH=$p/installed \\\
	INSTALL_MOD_DIR=kernel/lttng \\\
	KERNELDIR=%{_kernelsrcdir}\
%{nil}

%{expand:%kpkg}

%prep
%setup -q -n %{pname}-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
%{expand:%bkpkg}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT

cp -a installed/* $RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT
%changelog
* Fri Nov 28 2014 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/lttng-modules.git;a=log;h=auto/th/lttng-modules-2.5.1-3

* Sun Nov 23 2014 Jan Rękorajski <baggins@pld-linux.org> 9698438
- fix paths in patch

* Sun Nov 23 2014 Jan Rękorajski <baggins@pld-linux.org> 109f5cf
- fix building with 3.14.25
- rel 3

* Sun Nov 09 2014 Jan Rękorajski <baggins@pld-linux.org> 70ed592
- linux 3.17 fixes from upstream
- rel 2

* Sun Nov 09 2014 Jan Rękorajski <baggins@pld-linux.org> 7528c1a
- removed dumb build time check
- updated files

* Thu Oct 23 2014 Jakub Bogusz <qboosh@pld-linux.org> 0592aa2
- updated to 2.5.1, removed obsolete Update patches

* Mon Aug 25 2014 Jan Rękorajski <baggins@pld-linux.org> 13ceb69
- fixed building against linux 3.16, patches from
  https://github.com/openembedded/oe-core/tree/master/meta/recipes-kernel/lttng/lttng-modules
- rel 2

* Sat Aug 02 2014 Jakub Bogusz <qboosh@pld-linux.org> bb9b8f0
- updated to final 2.5.0

* Sat Jul 12 2014 Jan Rękorajski <baggins@pld-linux.org> d8a367a
- updated to 2.5.0-rc2

* Thu Jun 05 2014 Jan Rękorajski <baggins@pld-linux.org> 35688d2
- rel 3; add 3.10.41 and 3.14.5 to kernel with changes in blktrace

* Tue May 20 2014 Jan Rękorajski <baggins@pld-linux.org> e0ccd78
- fix build with latest kernels, rel 2

* Sun Apr 13 2014 Jakub Bogusz <qboosh@pld-linux.org> 9e789d6
- updated to 2.4.1

* Mon Mar 03 2014 Jakub Bogusz <qboosh@pld-linux.org> 70c552c
- updated to 2.4.0
- removed obsolete linux-3.13 patch

* Sat Feb 08 2014 Jan Rękorajski <baggins@pld-linux.org> d78989f
- upstream fixes for linux 3.13

* Sat Feb 08 2014 Jan Rękorajski <baggins@pld-linux.org> a9e9ed8
- up to 2.3.4

* Sat Nov 16 2013 Jakub Bogusz <qboosh@pld-linux.org> 43f25aa
- updated to 2.3.3

* Wed Nov 06 2013 Jan Rękorajski <baggins@pld-linux.org> 22b0fc7
- rel 6

* Sun Oct 27 2013 Jan Rękorajski <baggins@pld-linux.org> 3aed5ad
- only kernel modules here

* Sun Oct 27 2013 Jan Rękorajski <baggins@pld-linux.org> 85b0efa
- switch to macro driven module build for multiple kernel versions
- rel 5

* Mon Oct 07 2013 Jan Rękorajski <baggins@pld-linux.org> 23359d8
- rebuild for kernel-3.10.15-1
- release 4 (by relup.sh)

* Wed Oct 02 2013 Jan Rękorajski <baggins@pld-linux.org> ece90ff
- rebuild for kernel-3.10.14-1
- release 3 (by relup.sh)

